//+------------------------------------------------------------------+
//|                                                   Correction.mq4 |
//|                                         Copyright  2008, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kharko"
#property link      ""

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Aqua
#property  indicator_color2  Yellow

extern int    Bar       = 100;       // 
extern int    TimeStep  = 1;         // 

double   UpBuffer[],DownBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  if(TimeStep<=0)TimeStep=1;
//---- indicators
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION,STYLE_SOLID);
   SetIndexStyle(1,DRAW_SECTION,STYLE_SOLID);
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);

   IndicatorShortName("Correction ");
   SetIndexLabel(0,"Up "+TimeStep);
   SetIndexLabel(1,"Down "+TimeStep);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bar-counted_bars-TimeStep;

   if(limit<1)limit=TimeStep;
//---- 
//   if(UpBuffer[0]!=0) UpBuffer[0]=0;
//   if(DownBuffer[0]!=0)  DownBuffer[0]=0;
   int c=0;
   for(int i=0; i<limit; i++)
   {
      c++;
      if(c==TimeStep)c=0;
      else continue;
      if(Correction(i)==1)return(0);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int Correction(int sh)
  {
   double Max,Min,Max1,Min1;
   
//----
   Max=NormalizeDouble(iHigh(Symbol(),0,iHighest(Symbol(),0,MODE_HIGH,TimeStep,sh)),Digits);   
   Min=NormalizeDouble(iLow(Symbol(),0,iLowest(Symbol(),0,MODE_LOW,TimeStep,sh)),Digits);      
   Max1=NormalizeDouble(iHigh(Symbol(),0,iHighest(Symbol(),0,MODE_HIGH,TimeStep,sh+TimeStep)),Digits);   
   Min1=NormalizeDouble(iLow(Symbol(),0,iLowest(Symbol(),0,MODE_LOW,TimeStep,sh+TimeStep)),Digits);      
   
   if(Max!=0 && Min!=0 && Max1!=0 && Min1!=0)
   {
      UpBuffer[sh]=NormalizeDouble((Max-Min1)/Point,0);
      DownBuffer[sh]=NormalizeDouble((Min-Max1)/Point,0);
   }
   else return(1);
//----
   return(0);
  }

